#include "bsp_debug_uart.h"
#include "ws2812LED/bsp_ws2812LED.h"


/* 调试串口 UART0 初始化 */
void Debug_UART9_Init(void)
{
    fsp_err_t err = FSP_SUCCESS;

    err = R_SCI_UART_Open (&g_uart9_ctrl, &g_uart9_cfg);
    assert(FSP_SUCCESS == err);
}



/* 发送完成标志 */
volatile bool uart_send_complete_flag = false;


/* 串口中断回调 */
void debug_uart9_callback (uart_callback_args_t * p_args)
{
    switch (p_args->event)
    {
        case UART_EVENT_RX_CHAR:
        {
            /* 根据字符指令控制RGB彩灯颜色 */
            switch (p_args->data)
            {
                case '1':
                    WS2812B_Task1();
                    break;
                case '2':
                    WS2812B_Task2();
                    break;
                case '3':
                    WS2812B_Task3();
                    break;
                case '4':
                    WS2812B_Task4();
                    break;
                case '5':
                    WS2812B_Task5();
                    break;
                default:
                    break;
            }
            break;
        }
        case UART_EVENT_TX_COMPLETE:
        {
            uart_send_complete_flag = true;
            break;
        }
        default:
            break;
    }
}







