/*
 * ws2812.c
 *
 *  Created on: 2023年10月31日
 *      Author: Administrator
 */

#include "bsp_ws2812LED.h"
#include "hal_data.h"
extern fsp_err_t err ;
extern volatile bool g_transfer_complete ;

//灯条显存SPI数据缓存
uint8_t gWs2812bDat_SPI[WS2812B_AMOUNT * 24+88] = {0};
//灯条显存
tWs2812bCache_TypeDef gWs2812bDat[WS2812B_AMOUNT] = {
//R    G      B
0XFF, 0X00, 0X00,   //0
0X00, 0XFF, 0X00,   //1
0X00, 0X00, 0XFF,   //2
0X00, 0XFF, 0XFF,   //3
0XFF, 0X00, 0XFF,   //4
0XFF, 0XFF, 0X00,   //5
0XFF, 0XFF, 0XFF,   //6
0X0F, 0X0F, 0X0F,   //7

0XFF, 0X00, 0X00,   //0
0X00, 0XFF, 0X00,   //1
0X00, 0X00, 0XFF,   //2
0X00, 0XFF, 0XFF,   //3
0XFF, 0X00, 0XFF,   //4
0XFF, 0XFF, 0X00,   //5
0XFF, 0XFF, 0XFF,   //6
0X0F, 0X0F, 0X0F,   //7
};

//红色灯条显存
tWs2812bCache_TypeDef gWs2812bDat1[WS2812B_AMOUNT] = {
//R    G      B
0XFF, 0X00, 0X00,   //0
0XFF, 0X00, 0X00,   //1
0XFF, 0X00, 0X00,   //2
0XFF, 0X00, 0X00,   //3
0XFF, 0X00, 0X00,   //4
0XFF, 0X00, 0X00,   //5
0XFF, 0X00, 0X00,   //6
0XFF, 0X00, 0X00,   //7

0XFF, 0X00, 0X00,   //0
0XFF, 0X00, 0X00,   //1
0XFF, 0X00, 0X00,   //2
0XFF, 0X00, 0X00,   //3
0XFF, 0X00, 0X00,   //4
0XFF, 0X00, 0X00,   //5
0XFF, 0X00, 0X00,   //6
0XFF, 0X00, 0X00,   //7
};

//黄色灯条显存
tWs2812bCache_TypeDef gWs2812bDat2[WS2812B_AMOUNT] = {
//R    G      B
0XFF, 0XFF, 0X00,   //0
0XFF, 0XFF, 0X00,   //1
0XFF, 0XFF, 0X00,   //2
0XFF, 0XFF, 0X00,   //3
0XFF, 0XFF, 0X00,   //4
0XFF, 0XFF, 0X00,   //5
0XFF, 0XFF, 0X00,   //6
0XFF, 0XFF, 0X00,   //7

0XFF, 0XFF, 0X00,   //0
0XFF, 0XFF, 0X00,   //1
0XFF, 0XFF, 0X00,   //2
0XFF, 0XFF, 0X00,   //3
0XFF, 0XFF, 0X00,   //4
0XFF, 0XFF, 0X00,   //5
0XFF, 0XFF, 0X00,   //6
0XFF, 0XFF, 0X00,   //7
};

//绿色灯条显存
tWs2812bCache_TypeDef gWs2812bDat3[WS2812B_AMOUNT] = {
//R    G      B
0X00, 0XFF, 0X00,   //0
0X00, 0XFF, 0X00,   //1
0X00, 0XFF, 0X00,   //2
0X00, 0XFF, 0X00,   //3
0X00, 0XFF, 0X00,   //4
0X00, 0XFF, 0X00,   //5
0X00, 0XFF, 0X00,   //6
0X00, 0XFF, 0X00,   //7

0X00, 0XFF, 0X00,   //0
0X00, 0XFF, 0X00,   //1
0X00, 0XFF, 0X00,   //2
0X00, 0XFF, 0X00,   //3
0X00, 0XFF, 0X00,   //4
0X00, 0XFF, 0X00,   //5
0X00, 0XFF, 0X00,   //6
0X00, 0XFF, 0X00,   //7
};

//青绿色灯条显存
tWs2812bCache_TypeDef gWs2812bDat4[WS2812B_AMOUNT] = {
//R    G      B
0X00, 0XFF, 0XFF,   //0
0X00, 0XFF, 0XFF,   //1
0X00, 0XFF, 0XFF,   //2
0X00, 0XFF, 0XFF,   //3
0X00, 0XFF, 0XFF,   //4
0X00, 0XFF, 0XFF,   //5
0X00, 0XFF, 0XFF,   //6
0X00, 0XFF, 0XFF,   //7

0X00, 0XFF, 0XFF,   //0
0X00, 0XFF, 0XFF,   //1
0X00, 0XFF, 0XFF,   //2
0X00, 0XFF, 0XFF,   //3
0X00, 0XFF, 0XFF,   //4
0X00, 0XFF, 0XFF,   //5
0X00, 0XFF, 0XFF,   //6
0X00, 0XFF, 0XFF,   //7
};

//灭灯灯条显存
tWs2812bCache_TypeDef gWs2812bDat5[WS2812B_AMOUNT] = {
//R    G      B
0X00, 0X00, 0X00,   //0
0X00, 0X00, 0X00,   //1
0X00, 0X00, 0X00,   //2
0X00, 0X00, 0X00,   //3
0X00, 0X00, 0X00,   //4
0X00, 0X00, 0X00,   //5
0X00, 0X00, 0X00,   //6
0X00, 0X00, 0X00,   //7

0X00, 0X00, 0X00,   //0
0X00, 0X00, 0X00,   //1
0X00, 0X00, 0X00,   //2
0X00, 0X00, 0X00,   //3
0X00, 0X00, 0X00,   //4
0X00, 0X00, 0X00,   //5
0X00, 0X00, 0X00,   //6
0X00, 0X00, 0X00,   //7
};

void WS2812b_Set(uint16_t Ws2b812b_NUM, uint8_t r,uint8_t g,uint8_t b)
{
    uint8_t *pR = &gWs2812bDat_SPI[88+(Ws2b812b_NUM) * 24 + 8];
    uint8_t *pG = &gWs2812bDat_SPI[88+(Ws2b812b_NUM) * 24];
    uint8_t *pB = &gWs2812bDat_SPI[88+(Ws2b812b_NUM) * 24 + 16];

    for(uint8_t i = 0; i <  8; i++) {
        if(g & 0x80) {
            *pG = CODE_1;
        }
        else {
            *pG = CODE_0;
        }
        if(r & 0x80) {
            *pR = CODE_1;
        }
        else {
            *pR = CODE_0;
        }
        if(b & 0x80) {
            *pB = CODE_1;
        }
        else {
            *pB = CODE_0;
        }
        r <<= 1;
        g <<= 1;
        b <<= 1;
        pR++;
        pG++;
        pB++;
    }
}
void WS2812B_Task(void)
{
    uint8_t dat = 0;
    for(int i=0;i<88;i++)
    {
        gWs2812bDat_SPI[i]=0;

    }
    //将gWs2812bDat数据解析成SPI数据
    for(uint8_t iLED = 0; iLED < WS2812B_AMOUNT; iLED++)
    {
        WS2812b_Set(iLED, gWs2812bDat[iLED].R, gWs2812bDat[iLED].G, gWs2812bDat[iLED].B);
    }
    //总线输出数据

    /* Send the reset command */
    g_transfer_complete = false;
    err = R_SCI_SPI_Write(&g_spi0_ctrl, gWs2812bDat_SPI, sizeof(gWs2812bDat_SPI), SPI_BIT_WIDTH_8_BITS);
    assert(FSP_SUCCESS == err);
    /* Wait for SPI_EVENT_TRANSFER_COMPLETE callback event. */
    while (  g_transfer_complete==false)
    {
        ;
    }
     R_BSP_SoftwareDelay(1, BSP_DELAY_UNITS_MILLISECONDS);
}

void WS2812B_Task1(void)
{
    uint8_t dat = 0;
    for(int i=0;i<88;i++)
    {
        gWs2812bDat_SPI[i]=0;

    }
    //将gWs2812bDat数据解析成SPI数据
    for(uint8_t iLED = 0; iLED < WS2812B_AMOUNT; iLED++)
    {
        WS2812b_Set(iLED, gWs2812bDat1[iLED].R, gWs2812bDat1[iLED].G, gWs2812bDat1[iLED].B);
    }
    //总线输出数据

    /* Send the reset command */
    g_transfer_complete = false;
    err = R_SCI_SPI_Write(&g_spi0_ctrl, gWs2812bDat_SPI, sizeof(gWs2812bDat_SPI), SPI_BIT_WIDTH_8_BITS);
    assert(FSP_SUCCESS == err);
    /* Wait for SPI_EVENT_TRANSFER_COMPLETE callback event. */

    // R_BSP_SoftwareDelay(1, BSP_DELAY_UNITS_MILLISECONDS);
}

void WS2812B_Task2(void)
{
    uint8_t dat = 0;
    for(int i=0;i<88;i++)
    {
        gWs2812bDat_SPI[i]=0;

    }
    //将gWs2812bDat数据解析成SPI数据
    for(uint8_t iLED = 0; iLED < WS2812B_AMOUNT; iLED++)
    {
        WS2812b_Set(iLED, gWs2812bDat2[iLED].R, gWs2812bDat2[iLED].G, gWs2812bDat2[iLED].B);
    }
    //总线输出数据

    /* Send the reset command */
    g_transfer_complete = false;
    err = R_SCI_SPI_Write(&g_spi0_ctrl, gWs2812bDat_SPI, sizeof(gWs2812bDat_SPI), SPI_BIT_WIDTH_8_BITS);
    assert(FSP_SUCCESS == err);
    /* Wait for SPI_EVENT_TRANSFER_COMPLETE callback event. */

     //R_BSP_SoftwareDelay(1, BSP_DELAY_UNITS_MILLISECONDS);
}


void WS2812B_Task3(void)
{
    uint8_t dat = 0;
    for(int i=0;i<88;i++)
    {
        gWs2812bDat_SPI[i]=0;

    }
    //将gWs2812bDat数据解析成SPI数据
    for(uint8_t iLED = 0; iLED < WS2812B_AMOUNT; iLED++)
    {
        WS2812b_Set(iLED, gWs2812bDat3[iLED].R, gWs2812bDat3[iLED].G, gWs2812bDat3[iLED].B);
    }
    //总线输出数据

    /* Send the reset command */
    g_transfer_complete = false;
    err = R_SCI_SPI_Write(&g_spi0_ctrl, gWs2812bDat_SPI, sizeof(gWs2812bDat_SPI), SPI_BIT_WIDTH_8_BITS);
    assert(FSP_SUCCESS == err);
    /* Wait for SPI_EVENT_TRANSFER_COMPLETE callback event. */

    // R_BSP_SoftwareDelay(1, BSP_DELAY_UNITS_MILLISECONDS);
}


void WS2812B_Task4(void)
{
    uint8_t dat = 0;
    for(int i=0;i<88;i++)
    {
        gWs2812bDat_SPI[i]=0;

    }
    //将gWs2812bDat数据解析成SPI数据
    for(uint8_t iLED = 0; iLED < WS2812B_AMOUNT; iLED++)
    {
        WS2812b_Set(iLED, gWs2812bDat4[iLED].R, gWs2812bDat4[iLED].G, gWs2812bDat4[iLED].B);
    }
    //总线输出数据

    /* Send the reset command */
    g_transfer_complete = false;
    err = R_SCI_SPI_Write(&g_spi0_ctrl, gWs2812bDat_SPI, sizeof(gWs2812bDat_SPI), SPI_BIT_WIDTH_8_BITS);
    assert(FSP_SUCCESS == err);
    /* Wait for SPI_EVENT_TRANSFER_COMPLETE callback event. */

    // R_BSP_SoftwareDelay(1, BSP_DELAY_UNITS_MILLISECONDS);
}

void WS2812B_Task5(void)
{
    uint8_t dat = 0;
    for(int i=0;i<88;i++)
    {
        gWs2812bDat_SPI[i]=0;

    }
    //将gWs2812bDat数据解析成SPI数据
    for(uint8_t iLED = 0; iLED < WS2812B_AMOUNT; iLED++)
    {
        WS2812b_Set(iLED, gWs2812bDat5[iLED].R, gWs2812bDat5[iLED].G, gWs2812bDat5[iLED].B);
    }
    //总线输出数据

    /* Send the reset command */
    g_transfer_complete = false;
    err = R_SCI_SPI_Write(&g_spi0_ctrl, gWs2812bDat_SPI, sizeof(gWs2812bDat_SPI), SPI_BIT_WIDTH_8_BITS);
    assert(FSP_SUCCESS == err);
    /* Wait for SPI_EVENT_TRANSFER_COMPLETE callback event. */

    // R_BSP_SoftwareDelay(1, BSP_DELAY_UNITS_MILLISECONDS);
}


